# Create Custom Image - CreateCustomImage

## Overview

Create a custom image from the specified UHost instance.






## Definition

### Public Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Action**     | string  | Corresponding API command name, the current API is `CreateCustomImage`.                      | **Yes** |
| **PublicKey**  | string  | The user's public key can be obtained from [Console](https://console.scloudsg.com/uaccount/api_manage)                                             | **Yes** |
| **Signature**  | string  | User signature generated based on public key and API command, see [Signature Algorithm](/docs/api/summary/signature.md)  | **Yes** |

### Request Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Region** | string | Region. See [List of Regions and Availability Zones](/docs/api/summary/regionlist) |**Yes**|
| **Zone** | string | Availability Zone. See [Availability Zone List](/docs/api/summary/regionlist) |No|
| **ProjectId** | string | Project ID. If not filled in, the default project is used, sub-accounts must be filled in. Please refer to the [GetProjectList interface](/docs/api/summary/get_project_list). |No|
| **UHostId** | string | UHost Instance ID See [DescribeUHostInstance](api/uhost-api/describe_uhost_instance) |**Yes**|
| **ImageName** | string | Image Name |**Yes**|
| **ImageDescription** | string | Image Description |No|
| **Tag** | string | Image Business Group. Default: Default |No|
| **DataUDiskIds.N** | string | [Array] The list of associated cloud disk data disk id. Note: The cloud disk data disk needs to enable the snapshot service. |No|

### Response Field

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **RetCode** | int | Return status code. If it is 0, it means successful return. If it is not 0, it means failure. |**Yes**|
| **Action** | string | Operation command name. |**Yes**|
| **Message** | string | Returns an error message, providing detailed description when `RetCode` is non-zero. |No|
| **ImageId** | string | Image Id |No|
| **DataSnapshotIds** | array[string] | UDisk Data Disk Snapshot ID List |No|




## Example

### Request Example
    
```
https://api.scloudsg.com/?Action=CreateCustomImage
&Region=cn-bj2
&ProjectId=org-xxx
&UHostId=uhost-xxx
&ImageName=Test
&DataUDiskIds.N=TtzKXtvV
&Tag=bSyBHVKz
```

### Response Example
    
```json
{
  "Action": "CreateCustomImageResponse",
  "DataSnapshotIds": [
    "hoSgBxwr"
  ],
  "ImageId": "uimage-xxx",
  "RetCode": 0
}
```





